---
updatedAt: 2026-04-29T02:55:17.000Z
agentTools:
  projectIndex: https://developers.tetrascience.com/llms.txt
---

# Create New Pipeline

# OpenAPI definition

```json
{
  "openapi": "3.1.0",
  "info": {
    "title": "Pipelines",
    "version": "3.4"
  },
  "servers": [
    {
      "url": "https://api.tetrascience.com",
      "description": "Production Server"
    },
    {
      "url": "https://api.tetrascience-uat.com",
      "description": "User Acceptabce Server"
    },
    {
      "url": "https://api.tetrascience-dev.com",
      "description": "Development Server"
    }
  ],
  "security": [
    {
      "token": [],
      "orgSlug": []
    }
  ],
  "paths": {
    "/v1/pipeline/create": {
      "post": {
        "summary": "Create New Pipeline",
        "description": "",
        "operationId": "DL-FI-createPipeline",
        "tags": [
          "Pipelines"
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/PipelineInputObject"
              }
            }
          }
        },
        "responses": {
          "200": {
            "$ref": "#/components/responses/200PipelineObject"
          },
          "400": {
            "$ref": "#/components/responses/400Any"
          }
        }
      }
    }
  },
  "components": {
    "securitySchemes": {
      "token": {
        "type": "apiKey",
        "description": "JWT Token for authentication",
        "in": "header",
        "name": "ts-auth-token"
      },
      "orgSlug": {
        "type": "apiKey",
        "description": "Your organization slug",
        "in": "header",
        "name": "x-org-slug"
      }
    },
    "schemas": {
      "BasicPipelineInputObject": {
        "allOf": [
          {
            "$ref": "#/components/schemas/PipelineSettings"
          },
          {
            "type": "object",
            "properties": {
              "id": {
                "type": "string",
                "format": "uuid",
                "description": "ignored when provided in Query parameters"
              },
              "orgSlug": {
                "type": "string",
                "description": "ignored when provided in URL/Headers"
              },
              "message": {
                "type": "string"
              },
              "updatedAt": {
                "type": "string"
              },
              "labels": {
                "type": "array",
                "items": {
                  "$ref": "#/components/schemas/PipelineNestedLabel"
                }
              }
            }
          }
        ]
      },
      "FileTriggerInputPipeline": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasicPipelineInputObject"
          },
          {
            "type": "object",
            "required": [
              "triggerType",
              "triggerCondition"
            ],
            "properties": {
              "triggerType": {
                "type": "string",
                "enum": [
                  "custom"
                ]
              },
              "triggerCondition": {
                "oneOf": [
                  {
                    "type": "object",
                    "additionalProperties": false
                  },
                  {
                    "$ref": "#/components/schemas/TriggerConditionGroup"
                  }
                ]
              }
            }
          }
        ]
      },
      "ScheduledTriggerInputPipeline": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasicPipelineInputObject"
          },
          {
            "type": "object",
            "required": [
              "triggerType",
              "triggerCondition"
            ],
            "properties": {
              "triggerType": {
                "type": "string",
                "enum": [
                  "sched"
                ]
              },
              "triggerCondition": {
                "type": "object",
                "required": [
                  "cron",
                  "tz"
                ],
                "properties": {
                  "cron": {
                    "type": "string"
                  },
                  "tz": {
                    "type": "string"
                  }
                }
              }
            }
          }
        ]
      },
      "PipelineInputObject": {
        "oneOf": [
          {
            "$ref": "#/components/schemas/FileTriggerInputPipeline"
          },
          {
            "$ref": "#/components/schemas/ScheduledTriggerInputPipeline"
          }
        ]
      },
      "PipelineSettings": {
        "type": "object",
        "required": [
          "name"
        ],
        "properties": {
          "name": {
            "type": "string"
          },
          "description": {
            "oneOf": [
              {
                "type": "null"
              },
              {
                "type": "string"
              }
            ]
          },
          "protocolSlug": {
            "oneOf": [
              {
                "type": "null"
              },
              {
                "type": "string"
              }
            ],
            "deprecated": true
          },
          "protocolVersion": {
            "oneOf": [
              {
                "type": "null"
              },
              {
                "type": "string"
              }
            ],
            "deprecated": true
          },
          "priority": {
            "type": "integer",
            "default": 5
          },
          "retryBehavior": {
            "oneOf": [
              {
                "type": "null"
              },
              {
                "type": "string",
                "enum": [
                  "off",
                  "oom_only",
                  "linear",
                  "constant",
                  "exponential"
                ]
              }
            ]
          },
          "retryConfiguration": {
            "type": "object",
            "properties": {
              "baseDelaySeconds": {
                "type": "integer",
                "minimum": 0
              },
              "maxRetries": {
                "type": "integer",
                "minimum": 0
              }
            }
          },
          "standby": {
            "oneOf": [
              {
                "type": "null"
              },
              {
                "type": "integer"
              }
            ]
          },
          "status": {
            "oneOf": [
              {
                "type": "null"
              },
              {
                "type": "string",
                "enum": [
                  "disabled"
                ]
              }
            ]
          },
          "taskScriptTimeoutMins": {
            "oneOf": [
              {
                "type": "null"
              },
              {
                "type": "integer"
              }
            ]
          },
          "maxParallelWorkflows": {
            "type": "integer",
            "default": 0
          },
          "createdAt": {
            "type": "string"
          },
          "pipelineConfig": {
            "$ref": "#/components/schemas/PipelineConfig"
          },
          "stepsConfig": {
            "type": "object",
            "additionalProperties": {
              "$ref": "#/components/schemas/StepsConfig"
            },
            "default": {}
          },
          "artifactType": {
            "type": "string",
            "enum": [
              "protocol",
              "tetraflow"
            ],
            "default": "protocol"
          },
          "clusterId": {
            "deprecated": true,
            "oneOf": [
              {
                "type": "null"
              },
              {
                "type": "string"
              }
            ],
            "description": "DEPRECATED: Prefer clusterPolicyId for cost-effective ephemeral job clusters."
          },
          "clusterPolicyId": {
            "oneOf": [
              {
                "type": "null"
              },
              {
                "type": "string"
              }
            ],
            "description": "Databricks cluster policy ID for job clusters. Preferred over clusterId for cost-effective ephemeral compute. Takes precedence if both are provided."
          },
          "runOnDeleted": {
            "type": "boolean",
            "default": false
          },
          "masterScriptNamespace": {
            "oneOf": [
              {
                "type": "string"
              },
              {
                "type": "null"
              }
            ]
          },
          "masterScriptVersion": {
            "oneOf": [
              {
                "type": "string"
              },
              {
                "type": "null"
              }
            ]
          },
          "masterScriptSlug": {
            "oneOf": [
              {
                "type": "string"
              },
              {
                "type": "null"
              }
            ]
          },
          "inlineArtifact": {
            "oneOf": [
              {
                "type": "object",
                "format": "unknown"
              },
              {
                "type": "null"
              }
            ]
          }
        }
      },
      "BasicPipelineOutputObject": {
        "allOf": [
          {
            "$ref": "#/components/schemas/PipelineSettings"
          },
          {
            "type": "object",
            "properties": {
              "id": {
                "type": "string",
                "format": "uuid",
                "description": "ignored when provided in Query parameters"
              },
              "orgSlug": {
                "type": "string",
                "description": "ignored when provided in URL/Headers"
              },
              "revision": {
                "type": "number"
              },
              "updatedAt": {
                "type": "string"
              },
              "protocolSchema": {
                "type": "string",
                "enum": [
                  "v2",
                  "v3",
                  "tfv1"
                ]
              },
              "labels": {
                "type": "array",
                "items": {
                  "$ref": "#/components/schemas/PipelineNestedLabel"
                }
              }
            }
          }
        ]
      },
      "FileTriggerOutputPipeline": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasicPipelineOutputObject"
          },
          {
            "type": "object",
            "required": [
              "triggerType",
              "triggerCondition"
            ],
            "properties": {
              "triggerType": {
                "type": "string",
                "enum": [
                  "custom"
                ]
              },
              "triggerCondition": {
                "oneOf": [
                  {
                    "type": "object",
                    "additionalProperties": false
                  },
                  {
                    "$ref": "#/components/schemas/TriggerConditionGroup"
                  }
                ]
              }
            }
          }
        ]
      },
      "ScheduledTriggerOutputPipeline": {
        "allOf": [
          {
            "$ref": "#/components/schemas/BasicPipelineOutputObject"
          },
          {
            "type": "object",
            "required": [
              "triggerType",
              "triggerCondition"
            ],
            "properties": {
              "triggerType": {
                "type": "string",
                "enum": [
                  "sched"
                ]
              },
              "triggerCondition": {
                "type": "object",
                "required": [
                  "cron",
                  "tz"
                ],
                "properties": {
                  "cron": {
                    "type": "string"
                  },
                  "tz": {
                    "type": "string",
                    "description": "Java Timezone https://docs.oracle.com/javase/7/docs/api/java/util/TimeZone.html"
                  }
                }
              }
            }
          }
        ]
      },
      "PipelineOutputObject": {
        "oneOf": [
          {
            "$ref": "#/components/schemas/FileTriggerOutputPipeline"
          },
          {
            "$ref": "#/components/schemas/ScheduledTriggerOutputPipeline"
          }
        ]
      },
      "PipelineNestedLabel": {
        "type": "object",
        "required": [
          "name",
          "value"
        ],
        "properties": {
          "name": {
            "type": "string"
          },
          "value": {
            "type": "string"
          }
        }
      },
      "PipelineConfig": {
        "type": "object",
        "additionalProperties": {
          "anyOf": [
            {
              "type": "object",
              "additionalProperties": true
            },
            {
              "type": "array",
              "items": {}
            },
            {
              "type": "string"
            },
            {
              "type": "integer"
            },
            {
              "type": "number"
            },
            {
              "type": "boolean"
            },
            {
              "type": "null"
            },
            {
              "type": "object",
              "properties": {
                "ssm": {
                  "type": "string"
                },
                "secret": {
                  "type": "boolean"
                }
              }
            }
          ]
        }
      },
      "StepsConfig": {
        "type": "object",
        "properties": {
          "memoryInMB": {
            "type": "integer"
          },
          "runInLambda": {
            "type": "boolean"
          }
        }
      },
      "TriggerConditionGroup": {
        "type": "object",
        "required": [
          "groupLevel",
          "groupOperator",
          "groups"
        ],
        "properties": {
          "groupLevel": {
            "type": "integer"
          },
          "groupOperator": {
            "type": "string",
            "enum": [
              "AND",
              "OR"
            ]
          },
          "groups": {
            "type": "array",
            "items": {
              "oneOf": [
                {
                  "$ref": "#/components/schemas/TriggerConditionGroup"
                },
                {
                  "type": "object",
                  "required": [
                    "key",
                    "operator"
                  ],
                  "properties": {
                    "key": {
                      "type": "string"
                    },
                    "operator": {
                      "type": "string"
                    },
                    "value": {
                      "type": "string"
                    }
                  }
                }
              ]
            }
          }
        }
      }
    },
    "responses": {
      "200PipelineObject": {
        "description": "Success",
        "content": {
          "application/json": {
            "schema": {
              "$ref": "#/components/schemas/PipelineOutputObject"
            }
          }
        }
      },
      "400Any": {
        "description": "Incorrect input provided",
        "content": {
          "application/json": {
            "schema": {},
            "example": {
              "error": "Bad Request",
              "message": "Invalid parameters provided."
            }
          }
        }
      }
    }
  },
  "x-readme": {
    "headers": [
      {
        "key": "x-api-key",
        "value": "API_KEY"
      }
    ],
    "explorer-enabled": true,
    "proxy-enabled": true,
    "samples-enabled": true
  },
  "x-readme-fauxas": true
}
```